<template>
  <div>
    <div class="content-body">
      <div class="table-heading">
        <st-subtitle :text="'Tutores voluntarios ('+totalTutors+')'" />
        <st-show-all-button @showModal="showModalAddTutors" />
      </div>

      <v-text-field
        label="Buscar por nombre o código"
        v-model="searchQuery"
        append-icon="mdi-magnify"
        single-line
        hide-details
      />
      <!--   <st-data-table
      :dataInfo = "{ headers, items }"
      :loading = "loading || updatingTutorsTable"
      :sortby = "['Nombres', 'Código']"
      :sortdesc = "[true]"
      :search="searchQuery"
      :items-per-page="5"/>-->
      <v-data-table
        v-bind="{ headers, items }"
        :hide-default-footer="items.length <= 5"
        @click:row="itemSelected"
        :loading="loading || updatingTutorsTable"
        loading-text="Cargando..."
        no-data-text="No se encontraron resultados"
        :sort-by="sortby"
        :sort-desc="sortdesc"
        :search="searchQuery"
        :items-per-page="5"
      >
      <template v-slot:item.actions="{ item }">
      <v-icon 
        medium
        color = "primary"
        @click="open(item)"
      >
        mdi-delete
      </v-icon>
    </template></v-data-table>
    </div>
    <v-row justify="center">
    <v-dialog v-model="dialog2" persistent max-width="450">
      <v-card>
        <v-card-title class="headline">Eliminar tutor de la tutoría</v-card-title>
        <v-card-text class="my-2">¿Está seguro de eliminar al tutor? Puede volverlo a agregar en cualquier momento con el botón AGREGAR.</v-card-text>
        <v-card-actions >
            <v-row no-gutters justify="end">
        <v-spacer></v-spacer> 
          <v-btn color="primary" text @click="dialog2 = false">Volver</v-btn>
          <v-btn color="secondary" :loading="loadDel" text @click="deleteTutor">Eliminar</v-btn>
            </v-row>
        </v-card-actions>

      </v-card>
    </v-dialog>
  </v-row>
  </div>
  
</template>

<script>
import ShowAllTextButton from "./ShowAllTextButton";
import DataTablePopup from "./DataTablePopup";
import Search from "./Search";
import {mapState} from "vuex";

export default {
  components: {
    "st-data-table": DataTablePopup,
    "st-show-all-button": ShowAllTextButton,
    "st-search-text-field": Search,
  },
  data() { return {
    searchQuery: "",
    sortby : ['Nombres', 'Código'],
    sortdesc : [true],
    dialog2: false,
    sesion: null,
    loadDel : false,
  }},
  computed: {
    ...mapState('tutorships', {
      items: (state) => state.tutores,
      headers: (state) => state.tutorsTableHeaders2,
      showModalTutors: (state) => state.showModalTutors,
      totalTutors: (state) => state.totalTutores,
      loading: (state) => state.loading,
      updatingTutorsTable: (state) => state.updatingTutorsTable,
    }),
  },
  methods: {
    showModalAddTutors() {
      this.$store.dispatch('tutorships/showTutorsModal');
    },
    searchTutor(searchQuery) {
      const idTutorship = this.$route.params.id;
      this.$store.dispatch('tutorships/searchTutor', {
        idTutorship: idTutorship,
        searchQuery: searchQuery
      });
    },
     itemSelected(value) {
        this.$emit('itemSelected', value);
      },
      open(value){
       this.dialog2=true
      // this.componentKey += 1
       this.sesion = value
    },
    async deleteTutor(){
      this.loadDel = true
      try {
        let response = await this.$api.deleteTutorshipTutor(this.$route.params.id, this.sesion.idTutor)
        const idTutorship = this.$route.params.id;
        this.$store.dispatch('tutorships/updateTutorsInTutorship', {idTutorship: idTutorship, searchQuery: ""});
      } catch (e) {
        this.$store.commit('setError', e)
      }
       this.loadDel = false
        this.dialog2 = false
    }
  },
}
</script>

<style scoped>
</style>
